/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2024-02-17 15:45
 **/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b){ return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b){ return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MOD = 998'244'353;

const ll MAXN = 2e5 + 5;
const ll INF = 1LL << 60;

ll N;

void solve(){
    // Code goes here ...
    cin >> N;
    vector<ll> a(N);
    R(i, N) cin >> a[i];

    multiset<ll> s;
    R(i, N){
        // while(s.contains(a[i] + i)){
        //     a[i]--;
        // }
        s.insert(a[i] + i);
    }

    // add one to all elements
    vector<ll> b;
    for(auto x: s)
        b.push_back(x);
    R::reverse(b);

    ll biggest = INF;

    for(auto x : b){
        if(x > biggest){
            x = biggest;
        }
        biggest = x - 1;
        cout << x + 1 << " ";
    }
    
    cout << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
